<script setup>
import ProductItem from "./ProductItem.vue";
</script>

<template>
  <main class="layout">
    <aside class="filters" id="js-filters">
      <img
        src="@/assets/icons/close.svg"
        alt="Icône de fermeture des filtres"
        class="filters__close"
        id="js-close-filters"
        @click="closeFiltersMobile"
      />
      <form
        @change="onChange"
        class="filters"
        method="get"
        id="js-filters-form"
      >
        <section class="filters__column">
          <header class="filters__header">
            <h2 class="filters__title">Sexe</h2>
          </header>
          <div class="filters__column">
            <label class="filter__choice" for="male">
              <input
                id="male"
                class="filters__check"
                name="gender"
                type="checkbox"
                value="Homme"
              />
              Hommes
            </label>
            <label class="filter__choice" for="female">
              <input
                id="female"
                class="filters__check"
                name="gender"
                type="checkbox"
                value="Femme"
              />
              Femmes
            </label>
            <label class="filter__choice" for="both">
              <input
                id="both"
                class="filters__check"
                name="gender"
                type="checkbox"
                value="Mixte"
              />
              Mixte
            </label>
          </div>
        </section>
        <hr class="filters__separator" />
        <section class="filters__column">
          <header class="filters__header">
            <h2 class="filters__title">Rechercher par prix</h2>
          </header>
          <div class="filters__column">
            <label class="filter__choice" for="less-fifty">
              <input
                id="less-fifty"
                class="filters__check"
                name="price"
                type="checkbox"
              />
              Moins de €50
            </label>
            <label class="filter__choice" for="fifty-hundred">
              <input
                id="fifty-hundred"
                class="filters__check"
                name="price"
                type="checkbox"
              />
              €50 - €100
            </label>
            <label class="filter__choice" for="hundred-hundredfifty">
              <input
                id="hundred-hundredfifty"
                class="filters__check"
                name="price"
                type="checkbox"
              />
              €100 - €150
            </label>
            <label class="filter__choice" for="more-hundredfifty">
              <input
                id="more-hundredfifty"
                class="filters__check"
                name="price"
                type="checkbox"
              />
              Plus de 150€
            </label>
          </div>
        </section>
        <hr class="filters__separator" />
        <section>
          <header class="filters__header">
            <h2 class="filters__title">Couleur</h2>
          </header>
          <div class="filters__grid">
            <label class="filters__color" for="black">
              <input
                id="black"
                class="filters__check filters__check--hidden"
                name="color"
                type="checkbox"
              />
              <span
                class="filters__color-thumbnail filters__color-thumbnail--black"
              >
            <img
              alt="Filtre sélectionné"
              class="filters__selected"
              src="@/assets/icons/check.svg"
            />
          </span>
              Noir
            </label>
            <label class="filters__color" for="red">
              <input
                id="red"
                class="filters__check filters__check--hidden"
                name="color"
                type="checkbox"
              />
              <span class="filters__color-thumbnail filters__color-thumbnail--red">
            <img
              alt="Filtre sélectionné"
              class="filters__selected"
              src="@/assets/icons/check.svg"
            />
          </span>
              Rouge
            </label>
            <label class="filters__color" for="white">
              <input
                id="white"
                class="filters__check filters__check--hidden"
                name="color"
                type="checkbox"
              />
              <span class="filters__color-thumbnail filters__color-thumbnail--white">
            <img
              alt="Filtre sélectionné"
              class="filters__selected"
              src="@/assets/icons/check.svg"
            />
          </span>
              Blanc
            </label>
            <label for="yellow" class="filters__color">
              <input
                type="checkbox"
                name="color"
                id="yellow"
                class="filters__check filters__check--hidden"
              />
              <span
                class="filters__color-thumbnail filters__color-thumbnail--yellow"
              >
            <img
              src="@/assets/icons/check.svg"
              alt="Filtre sélectionné"
              class="filters__selected"
            />
          </span>
              Jaune
            </label>
            <label for="green" class="filters__color">
              <input
                type="checkbox"
                name="color"
                id="green"
                class="filters__check filters__check--hidden"
              />
              <span
                class="filters__color-thumbnail filters__color-thumbnail--green"
              >
            <img
              src="@/assets/icons/check.svg"
              alt="Filtre sélectionné"
              class="filters__selected"
            />
          </span>
              Vert
            </label>
            <label for="blue" class="filters__color">
              <input
                type="checkbox"
                name="color"
                id="blue"
                class="filters__check filters__check--hidden"
              />
              <span
                class="filters__color-thumbnail filters__color-thumbnail--blue"
              >
            <img
              src="@/assets/icons/check.svg"
              alt="Filtre sélectionné"
              class="filters__selected"
            />
          </span>
              Bleu
            </label>
            <label for="pink" class="filters__color">
              <input
                type="checkbox"
                name="color"
                id="pink"
                class="filters__check filters__check--hidden"
              />
              <span
                class="filters__color-thumbnail filters__color-thumbnail--pink"
              >
            <img
              src="@/assets/icons/check.svg"
              alt="Filtre sélectionné"
              class="filters__selected"
            />
          </span>
              Rose
            </label>
            <label for="gray" class="filters__color">
              <input
                type="checkbox"
                name="color"
                id="gray"
                class="filters__check filters__check--hidden"
              />
              <span
                class="filters__color-thumbnail filters__color-thumbnail--gray"
              >
            <img
              src="@/assets/icons/check.svg"
              alt="Filtre sélectionné"
              class="filters__selected"
            />
          </span>
              Gris
            </label>
          </div>
        </section>
        <hr class="filters__separator" />
        <section class="filters__sports">
          <section class="filters__header">
            <h2 class="filters__title">Sport</h2>
          </section>
          <div class="filters__column">
            <label class="filters__choice" for="football">
              <input
                id="football"
                class="filters__check"
                name="sport"
                type="checkbox"
                value="Football"
              />
              Football
            </label>
            <label class="filters__choice" for="basketball">
              <input
                id="basketball"
                class="filters__check"
                name="sport"
                type="checkbox"
                value="Basket"
              />
              Basket-Ball
            </label>
            <label class="filters__choice" for="running">
              <input
                id="running"
                class="filters__check"
                name="sport"
                type="checkbox"
                value="Running"
              />
              Running
            </label>
          </div>
        </section>
        <section class="filters__buttons">
          <input class="filters__button" type="reset" value="Effacer" />
          <input
            class="filters__button filters__button--black"
            type="submit"
            value="Appliquer"
          />
        </section>
      </form>
    </aside>
    <section class="products">
      <header class="products__header">
        <h1 class="products__title">
          Nouveautés
          <span v-if="genderFilters.value !== ''">{{
            genderFilters.value
          }}</span>
        </h1>
        <img
          src="@/assets/icons/filter.svg"
          alt="Icône de filtrage"
          class="products__filter-icon"
          @click="displayFiltersMobile"
        />
      </header>
      <section class="products__grid">
        <ProductItem
          v-for="(product, index) in filter"
          :key="index"
          :product="product"
        />
      </section>
    </section>
  </main>
</template>

<script>
import { products } from "../server/produits.json";
import { ref } from "vue";

let genderFilters = ref("");
let sportFilter = ref("");

export default {
  name: "Layout",
  data() {
    return {
      genderFilters,
    };
  },
  computed: {
    filter() {
      if (genderFilters.value !== "") {
        return products.filter((product) => {
          return product.sexe === genderFilters.value;
        });
      }
      if (sportFilter.value !== "") {
        return products.filter((product) => {
          return product.sport === sportFilter.value;
        });
      }
      return products;
    },
  },
  methods: {
    onChange(event) {
      // disable refresh
      event.preventDefault();
      // gender filter
      if (event.target.checked && event.target.name === "gender") {
        genderFilters.value = event.target.value;
      } else {
        genderFilters.value = "";
      }
      // sport filter
      if (event.target.checked && event.target.name === "sport") {
        sportFilter.value = event.target.value;
      } else {
        sportFilter.value = "";
      }
    },
    displayFiltersMobile() {
      document.getElementById("js-filters").style.display = "unset";
      document.getElementById("js-filters-form").style.display = "unset";
    },
    closeFiltersMobile() {
      document.getElementById("js-filters").style.display = "none";
      document.getElementById("js-filters-form").style.display = "none";
    },
  },
};
</script>

<style scoped lang="scss">
.layout {
  @media screen and (min-width: 1200px) {
    display: grid;
    grid-template-columns: 20% 80%;
  }
}

// filters
.filters {
  height: 100vh;
  width: 100vw;
  background-color: white;
  position: fixed;
  top: 0;
  left: 0;
  z-index: 100;
  padding: 4rem 2rem;
  display: none;

  @media screen and (min-width: 1200px) {
    position: relative;
    display: unset;
    grid-column: 1;
    width: 100%;
    height: unset;
    padding: 6rem 1rem;
    background-color: transparent;
  }

  &__close {
    position: absolute;
    top: 2rem;
    right: 2rem;
    z-index: 101;
    height: 30px;
    width: 30px;

    @media screen and (min-width: 1200px) {
      display: none;
    }
  }
}

// products
.products {
  position: relative;
  z-index: 0;

  @media screen and (min-width: 1200px) {
    grid-column: 2;
    position: unset;
  }
  // header
  &__header {
    width: 100%;
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding: 2rem 1rem;
  }

  &__title {
    font-size: 24px;
    font-weight: bold;

    @media screen and (min-width: 1200px) {
      position: absolute;
      top: 2rem;
      left: 2rem;
    }
  }

  &__filter-icon {
    height: 20px;
    width: 20px;

    @media screen and (min-width: 1200px) {
      display: none;
    }
  }

  // grid
  &__grid {
    display: grid;
    grid-template-columns: repeat(2, 1fr);
    column-gap: 0.5rem;
    row-gap: 2rem;

    @media screen and (min-width: 1200px) {
      grid-template-columns: repeat(3, 1fr);
      margin-top: 2rem;
    }
  }
}

.filters {
  &__separator {
    border: 0.5px solid gray;
    border-radius: 10px;
    opacity: 0.4;
    margin: 2rem 0;
  }

  &__column {
    display: flex;
    flex-direction: column;
    gap: 1rem;

    @media screen and (min-width: 1200px) {
      width: fit-content;
    }
  }

  &__title {
    margin-bottom: 1rem;
  }

  &__grid {
    display: grid;
    grid-template-columns: repeat(3, 1fr);
  }

  &__selected {
    opacity: 0;
    filter: invert(100%);
    height: 40%;
    width: 40%;
    transition: opacity 1s;
  }

  &__color {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    font-size: 12px;

    &-thumbnail {
      height: 30px;
      width: 30px;
      border-radius: 50%;
      margin-bottom: 0.5rem;
      display: flex;
      justify-content: center;
      align-items: center;

      &--black {
        background-color: black;
      }

      &--red {
        background-color: red;
      }

      &--white {
        border: 1px solid black;
      }

      &--yellow {
        background-color: yellow;
      }

      &--green {
        background-color: lightgreen;
      }

      &--blue {
        background-color: lightblue;
      }

      &--pink {
        background-color: pink;
      }

      &--gray {
        background-color: gray;
      }
    }
  }

  &__check {
    &--hidden {
      opacity: 0;
    }
  }

  &__buttons {
    display: flex;
    position: fixed;
    justify-content: space-between;
    bottom: 0;
    left: 0;
    padding: 2rem;
    border-top: 1px solid gray;
    width: 100%;
    gap: 1rem;
    background-color: white;
    z-index: 102;

    @media screen and (min-width: 1200px) {
      display: none;
    }
  }

  &__button {
    width: 50%;
    padding: 0.75rem;
    background-color: transparent;
    border: 1px solid black;
    border-radius: 30px;

    &--black {
      background-color: black;
      color: white;
    }
  }

  &__sports {
    padding-bottom: 10rem;
  }
}
</style>
